﻿using DevExpress.Mvvm;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace LoadingDecorator
{
    public class MainViewModel:INotifyPropertyChanged
    {
        private string processItem;

        public string ProcessItem
        {
            get { return processItem; }
            set
            {
                processItem = value;
                if (null != PropertyChanged)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("ProcessItem"));
                }
            }
        }

        private string itemProgress;

        public string ItemProgress
        {
            get { return itemProgress; }
            set { itemProgress = value;
                if(null != PropertyChanged)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("ItemProgress"));
                }
            }
        }
        private bool isLoading;
        public bool IsLoading
        {
            get { return isLoading; }
            set
            {
                isLoading = value;
                if (null != PropertyChanged)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("IsLoading"));
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public DelegateCommand<object> BeginCommand { get; set; }
        public MainViewModel()
        {
            BeginCommand = new DelegateCommand<object>(BeginExecute);
            IsLoading = false;
        }

        private void BeginExecute(object obj)
        {
            IsLoading = true;
            Task.Run(new Action(() => {
                for (int j = 0; j < 5; j++)
                {
                    ProcessItem = "步骤" + (j + 1) + "执行";
                    for (int i = 0; i < 100; i++)
                    {
                        Thread.Sleep(100);
                        ItemProgress = string.Format("步骤{0}，执行进度{1}/100", j + 1, i);
                    }
                }
                IsLoading = false;
            }));
            
        }
    }
}
